local addon, ns = ...
local C, F, G, L = unpack(ns)
local Minimap, EasyMenu, ToggleDropDownMenu = Minimap, EasyMenu, ToggleDropDownMenu

local function OnEvent()
	if not EKMinimapDB["ClickMenu"] then return end
	
	-- Right Click Menu List
	local menuFrame = CreateFrame("Frame", "MinimapRightClickMenu", UIParent, "UIDropDownMenuTemplate")
	local menuList = {
		{	-- 標題
			text = MAINMENU_BUTTON,
			isTitle = true,
			notCheckable = true,
		},
		{	-- 角色
			text = CHARACTER_BUTTON,
			icon = "Interface\\PaperDollInfoFrame\\UI-EquipmentManager-Toggle",
			func = function()
				securecall(ToggleCharacter, "PaperDollFrame") 
			end,
			notCheckable = true,
		},
		{	-- 法術書
			text = SPELLBOOK_ABILITIES_BUTTON,
			icon = "Interface\\MINIMAP\\TRACKING\\Class",
			func = function() 
				--securecall(ToggleSpellBook, SpellBookFrame)
				if not SpellBookFrame:IsShown() then
					ShowUIPanel(SpellBookFrame)
				else
					HideUIPanel(SpellBookFrame)
				end
			end,
			notCheckable = true,
		},
		{	--天賦
			text = TALENTS,
			icon = "Interface\\MINIMAP\\TRACKING\\Ammunition",
			func = function()
				if (not PlayerTalentFrame) then
					LoadAddOn("Blizzard_TalentUI")
				end
				if (not GlyphFrame) then
					LoadAddOn("Blizzard_GlyphUI")
				end
				securecall(ToggleTalentFrame)
			end,
			notCheckable = true,
		},
		{	-- 成就
			text = ACHIEVEMENT_BUTTON,
			icon = "Interface\\ACHIEVEMENTFRAME\\UI-Achievement-Shield",
			func = function()
				securecall(ToggleAchievementFrame)
			end,
			notCheckable = true,
		},
		{	-- 任務日誌
			text = QUESTLOG_BUTTON,	-- OLD: QUESTLOG_BUTTON
			icon = "Interface\\GossipFrame\\ActiveQuestIcon",
			func = function()
				securecall(ToggleFrame, QuestLogFrame)
			end,
			notCheckable = true,
		},
		{	-- 地圖
			text = WORLD_MAP,	-- OLD: QUESTLOG_BUTTON
			--icon = "Interface\\GossipFrame\\ActiveQuestIcon",
			icon = "Interface\\WorldMap\\UI-World-Icon",
			func = function() 
				securecall(ToggleFrame, WorldMapFrame)
				MaximizeUIPanel(WorldMapFrame)
			end,
			notCheckable = true,
		},
		{	-- 好友
			text = SOCIAL_BUTTON,
			icon = "Interface\\FriendsFrame\\UI-Toast-ChatInviteIcon",
			func = function()
				securecall(ToggleFriendsFrame, 1) 
			end,
			notCheckable = true,
		},
		{	-- 空行
			text = "",
			isTitle = true,
			notCheckable = true,
		},
		{	-- 其他
			text = OTHER,
			isTitle = true,
			notCheckable = true,
		},
		{	-- 團隊
			text = RAID,
			icon = "Interface\\Buttons\\UI-GuildButton-PublicNote-Up",
			func = function() 
				securecall(ToggleFriendsFrame, 4)
			end,
			notCheckable = true,
		},
		{	-- 客服支援
			text = GM_EMAIL_NAME,
			icon = "Interface\\CHATFRAME\\UI-ChatIcon-Blizz",
			func = function()
				securecall(ToggleHelpFrame) 
			end,
			notCheckable = true,
		},
		{	-- 語音
			text = CHANNEL,
			icon = "Interface\\CHATFRAME\\UI-ChatIcon-ArmoryChat-AwayMobile",
			func = function()
				ToggleChannelFrame()
			end,
			notCheckable = true
		},
		{	-- 碼表
			text = STOPWATCH_TITLE,
			icon = "Interface\\Icons\\INV_Misc_PocketWatch_01",
			func = function()
				ToggleFrame(TimeManagerFrame)
			end,
			notCheckable = true
		},
		{	-- 行事曆
			text = L.Calendar,
			func = function()
				if not CalendarFrame then 
					LoadAddOn("Blizzard_Calendar")
				end
				Calendar_Toggle()
			end,
			notCheckable = true,
		},
		{	-- 區域地圖
			text = BATTLEFIELD_MINIMAP,
			colorCode = "|cff999999",
			func = function()
				if not BattlefieldMapFrame then 
					LoadAddOn("Blizzard_BattlefieldMap") 
				end
				BattlefieldMapFrame:Toggle()
			end,
			notCheckable = true,
		},
		{
			text = L.ToggleConfig,
			colorCode = "|cff00FFFF",
			func = function()
				F.CreateOptions()
			end,
			notCheckable = true,
		},
		{	-- 空行
			text = "",
			isTitle = true,
			notCheckable = true,
		},
		{	-- 重載
			text = RELOADUI,
			colorCode = "|cff999999",
			func = function()
				ReloadUI()
			end,
			notCheckable = true,
		},
	}

	-- Right Click for Game Menu / 右鍵遊戲選單
	Minimap:SetScript("OnMouseUp", function(self, button)
		if button == "RightButton" then
			EasyMenu(menuList, menuFrame, self, (Minimap:GetWidth() * .7), -3, "MENU", 2)
		elseif button == "MiddleButton" then
			ToggleDropDownMenu(1, nil, MiniMapTrackingDropDown, self, (Minimap:GetWidth() * .7), -3, nil, nil, 2)
		else
			Minimap_OnClick(self)
		end
	end)
end

local frame = CreateFrame("FRAME")
frame:RegisterEvent("PLAYER_LOGIN")
frame:SetScript("OnEvent", OnEvent)

-- avoid taint / 避免taint
local initialize = CreateFrame("Frame")
	initialize:SetScript("OnEvent", function()
		ShowUIPanel(SpellBookFrame)
		HideUIPanel(SpellBookFrame)
	end)
	initialize:RegisterEvent("PLAYER_ENTERING_WORLD")